Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34921)
@@ -2308,16 +3576,58 @@
         },
     },
-    0xc6f6 => 'AsShotProfileName',
-    0xc6f7 => 'NoiseReductionApplied',
-    0xc6f8 => 'ProfileName',
-    0xc6f9 => 'ProfileHueSatMapDims',
-    0xc6fa => 'ProfileHueSatMapData1',
-    0xc6fb => 'ProfileHueSatMapData2',
+    0xc6f6 => {
+        Name => 'AsShotProfileName',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        %utf8StringConv,
+    },
+    0xc6f7 => {
+        Name => 'NoiseReductionApplied',
+        Writable => 'rational64u',
+        WriteGroup => 'SubIFD',
+        Protected => 1,
+    },
+    0xc6f8 => {
+        Name => 'ProfileName',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        %utf8StringConv,
+    },
+    0xc6f9 => {
+        Name => 'ProfileHueSatMapDims',
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+        Count => 3,
+        Protected => 1,
+    },
+    0xc6fa => {
+        Name => 'ProfileHueSatMapData1',
+        %longBin,
+        Writable => 'float',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc6fb => {
+        Name => 'ProfileHueSatMapData2',
+        %longBin,
+        Writable => 'float',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
     0xc6fc => {
         Name => 'ProfileToneCurve',
+        Writable => 'float',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
         Binary => 1,
     },
     0xc6fd => {
         Name => 'ProfileEmbedPolicy',
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
         PrintConv => {
             0 => 'Allow Copying',
@@ -2327,71 +3637,412 @@
         },
     },
-    0xc6fe => 'ProfileCopyright',
-    0xc714 => 'ForwardMatrix1',
-    0xc715 => 'ForwardMatrix2',
-    0xc716 => 'PreviewApplicationName',
-    0xc717 => 'PreviewApplicationVersion',
-    0xc718 => 'PreviewSettingsName',
+    0xc6fe => {
+        Name => 'ProfileCopyright',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        %utf8StringConv,
+    },
+    0xc714 => {
+        Name => 'ForwardMatrix1',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc715 => {
+        Name => 'ForwardMatrix2',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc716 => {
+        Name => 'PreviewApplicationName',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        %utf8StringConv,
+    },
+    0xc717 => {
+        Name => 'PreviewApplicationVersion',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        %utf8StringConv,
+    },
+    0xc718 => {
+        Name => 'PreviewSettingsName',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        %utf8StringConv,
+    },
     0xc719 => {
         Name => 'PreviewSettingsDigest',
         Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
         ValueConv => 'unpack("H*", $val)',
-    },
-    0xc71a => 'PreviewColorSpace',
+        ValueConvInv => 'pack("H*", $val)',
+    },
+    0xc71a => {
+        Name => 'PreviewColorSpace',
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Gray Gamma 2.2',
+            2 => 'sRGB',
+            3 => 'Adobe RGB',
+            4 => 'ProPhoto RGB',
+        },
+    },
     0xc71b => {
         Name => 'PreviewDateTime',
         Groups => { 2 => 'Time' },
+        Writable => 'string',
+        Shift => 'Time',
+        WriteGroup => 'IFD0',
+        Protected => 1,
         ValueConv => q{
             require Image::ExifTool::XMP;
             return Image::ExifTool::XMP::ConvertXMPDate($val);
         },
+        ValueConvInv => q{
+            require Image::ExifTool::XMP;
+            return Image::ExifTool::XMP::FormatXMPDate($val);
+        },
+        PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val,1,1)',
     },
     0xc71c => {
         Name => 'RawImageDigest',
         Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Count => 16,
+        Protected => 1,
         ValueConv => 'unpack("H*", $val)',
+        ValueConvInv => 'pack("H*", $val)',
     },
     0xc71d => {
         Name => 'OriginalRawFileDigest',
         Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Count => 16,
+        Protected => 1,
         ValueConv => 'unpack("H*", $val)',
+        ValueConvInv => 'pack("H*", $val)',
     },
     0xc71e => 'SubTileBlockSize',
     0xc71f => 'RowInterleaveFactor',
-    0xc725 => 'ProfileLookTableDims',
+    0xc725 => {
+        Name => 'ProfileLookTableDims',
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+        Count => 3,
+        Protected => 1,
+    },
     0xc726 => {
         Name => 'ProfileLookTableData',
+        Writable => 'float',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
         Binary => 1,
     },
-    0xc740 => { # DNG 1.3
-        Name => 'OpcodeList1',
-        Binary => 1,
-        # opcodes:
-        # 1 => 'WarpRectilinear',
-        # 2 => 'WarpFisheye',
-        # 3 => 'FixVignetteRadial',
-        # 4 => 'FixBadPixelsConstant',
-        # 5 => 'FixBadPixelsList',
-        # 6 => 'TrimBounds',
-        # 7 => 'MapTable',
-        # 8 => 'MapPolynomial',
-        # 9 => 'GainMap',
-        # 10 => 'DeltaPerRow',
-        # 11 => 'DeltaPerColumn',
-        # 12 => 'ScalePerRow',
-        # 13 => 'ScalePerColumn',
-    },
-    0xc741 => { # DNG 1.3
-        Name => 'OpcodeList2',
-        Binary => 1,
-    },
-    0xc74e => { # DNG 1.3
-        Name => 'OpcodeList3',
-        Binary => 1,
-    },
-    0xc761 => 'NoiseProfile', # DNG 1.3
+    0xc740 => { Name => 'OpcodeList1', %opcodeInfo }, # DNG 1.3
+    0xc741 => { Name => 'OpcodeList2', %opcodeInfo }, # DNG 1.3
+    0xc74e => { Name => 'OpcodeList3', %opcodeInfo }, # DNG 1.3
+    0xc761 => { # DNG 1.3
+        Name => 'NoiseProfile',
+        Writable => 'double',
+        WriteGroup => 'SubIFD',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc763 => { #28
+        Name => 'TimeCodes',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Count => -1, # (8 * number of time codes, max 10)
+        ValueConv => q{
+            my @a = split ' ', $val;
+            my @v;
+            push @v, join('.', map { sprintf('%.2x',$_) } splice(@a,0,8)) while @a >= 8;
+            join ' ', @v;
+        },
+        ValueConvInv => q{
+            my @a = map hex, split /[. ]+/, $val;
+            join ' ', @a;
+        },
+        # Note: Currently ignore the flags:
+        #   byte 0 0x80 - color frame
+        #   byte 0 0x40 - drop frame
+        #   byte 1 0x80 - field phase
+        PrintConv => q{
+            my @a = map hex, split /[. ]+/, $val;
+            my @v;
+            while (@a >= 8) {
+                my $str = sprintf("%.2x:%.2x:%.2x.%.2x", $a[3]&0x3f,
+                                 $a[2]&0x7f, $a[1]&0x7f, $a[0]&0x3f);
+                if ($a[3] & 0x80) { # date+timezone exist if BGF2 is set
+                    my $tz = $a[7] & 0x3f;
+                    my $bz = sprintf('%.2x', $tz);
+                    $bz = 100 if $bz =~ /[a-f]/i; # not BCD
+                    if ($bz < 26) {
+                        $tz = ($bz < 13 ? 0 : 26) - $bz;
+                    } elsif ($bz == 32) {
+                        $tz = 12.75;
+                    } elsif ($bz >= 28 and $bz <= 31) {
+                        $tz = 0;    # UTC
+                    } elsif ($bz < 100) {
+                        undef $tz;  # undefined or user-defined
+                    } elsif ($tz < 0x20) {
+                        $tz = (($tz < 0x10 ? 10 : 20) - $tz) - 0.5;
+                    } else {
+                        $tz = (($tz < 0x30 ? 53 : 63) - $tz) + 0.5;
+                    }
+                    if ($a[7] & 0x80) { # MJD format (/w UTC time)
+                        my ($h,$m,$s,$f) = split /[:.]/, $str;
+                        my $jday = sprintf('%x%.2x%.2x', reverse @a[4..6]);
+                        $str = ConvertUnixTime(($jday - 40587) * 24 * 3600
+                                 + ((($h+$tz) * 60) + $m) * 60 + $s) . ".$f";
+                        $str =~ s/^(\d+):(\d+):(\d+) /$1-$2-${3}T/;
+                    } else { # YYMMDD (Note: CinemaDNG 1.1 example seems wrong)
+                        my $yr = sprintf('%.2x',$a[6]) + 1900;
+                        $yr += 100 if $yr < 1970;
+                        $str = sprintf('%d-%.2x-%.2xT%s',$yr,$a[5],$a[4],$str);
+                    }
+                    $str .= TimeZoneString($tz*60) if defined $tz;
+                }
+                push @v, $str;
+                splice @a, 0, 8;
+            }
+            join ' ', @v;
+        },
+        PrintConvInv => q{
+            my @a = split ' ', $val;
+            my @v;
+            foreach (@a) {
+                my @td = reverse split /T/;
+                my $tz = 0x39; # default to unknown timezone
+                if ($td[0] =~ s/([-+])(\d+):(\d+)$//) {
+                    if ($3 == 0) {
+                        $tz = hex(($1 eq '-') ? $2 : 0x26 - $2);
+                    } elsif ($3 == 30) {
+                        if ($1 eq '-') {
+                            $tz = $2 + 0x0a;
+                            $tz += 0x0a if $tz > 0x0f;
+                        } else {
+                            $tz = 0x3f - $2;
+                            $tz -= 0x0a if $tz < 0x3a;
+                        }
+                    } elsif ($3 == 45) {
+                        $tz = 0x32 if $1 eq '+' and $2 == 12;
+                    }
+                }
+                my @t = split /[:.]/, $td[0];
+                push @t, '00' while @t < 4;
+                my $bg;
+                if ($td[1]) {
+                    # date was specified: fill in date & timezone
+                    my @d = split /[-]/, $td[1];
+                    next if @d < 3;
+                    $bg = sprintf('.%.2d.%.2d.%.2d.%.2x', $d[2], $d[1], $d[0]%100, $tz);
+                    $t[0] = sprintf('%.2x', hex($t[0]) + 0xc0); # set BGF1+BGF2
+                } else { # time only
+                    $bg = '.00.00.00.00';
+                }
+                push @v, join('.', reverse(@t[0..3])) . $bg;
+            }
+            join ' ', @v;
+        },
+    },
+    0xc764 => { #28
+        Name => 'FrameRate',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        PrintConv => 'int($val * 1000 + 0.5) / 1000',
+        PrintConvInv => '$val',
+    },
+    0xc772 => { #28
+        Name => 'TStop',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => -1, # (1 or 2)
+        PrintConv => 'join("-", map { sprintf("%.2f",$_) } split " ", $val)',
+        PrintConvInv => '$val=~tr/-/ /; $val',
+    },
+    0xc789 => { #28
+        Name => 'ReelName',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+    },
+    0xc791 => { # DNG 1.4
+        Name => 'OriginalDefaultFinalSize',
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+        Count => 2,
+        Protected => 1,
+    },
+    0xc792 => { # DNG 1.4
+        Name => 'OriginalBestQualitySize',
+        Notes => 'called OriginalBestQualityFinalSize by the DNG spec',
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+        Count => 2,
+        Protected => 1,
+    },
+    0xc793 => { # DNG 1.4
+        Name => 'OriginalDefaultCropSize',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => 2,
+        Protected => 1,
+    },
+    0xc7a1 => {  #28
+        Name => 'CameraLabel',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+    },
+    0xc7a3 => { # DNG 1.4
+        Name => 'ProfileHueSatMapEncoding',
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        PrintConv => {
+            0 => 'Linear',
+            1 => 'sRGB',
+        },
+    },
+    0xc7a4 => { # DNG 1.4
+        Name => 'ProfileLookTableEncoding',
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        PrintConv => {
+            0 => 'Linear',
+            1 => 'sRGB',
+        },
+    },
+    0xc7a5 => { # DNG 1.4
+        Name => 'BaselineExposureOffset',
+        Writable => 'rational64s', # (incorrectly "RATIONAL" in DNG 1.4 spec)
+        WriteGroup => 'IFD0',
+        Protected => 1,
+    },
+    0xc7a6 => { # DNG 1.4
+        Name => 'DefaultBlackRender',
+        Writable => 'int32u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        PrintConv => {
+            0 => 'Auto',
+            1 => 'None',
+        },
+    },
+    0xc7a7 => { # DNG 1.4
+        Name => 'NewRawImageDigest',
+        Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Count => 16,
+        Protected => 1,
+        ValueConv => 'unpack("H*", $val)',
+        ValueConvInv => 'pack("H*", $val)',
+    },
+    0xc7a8 => { # DNG 1.4
+        Name => 'RawToPreviewGain',
+        Writable => 'double',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+    },
+    # 0xc7a9 - CacheBlob (ref 31)
+    0xc7aa => { #31 undocumented DNG tag written by LR4 (val=256, related to fast load data?)
+        Name => 'CacheVersion',
+        Writable => 'int32u',
+        WriteGroup => 'SubIFD2',
+        Format => 'int8u',
+        Count => 4,
+        Protected => 1,
+        PrintConv => '$val =~ tr/ /./; $val',
+        PrintConvInv => '$val =~ tr/./ /; $val',
+    },
+    0xc7b5 => { # DNG 1.4
+        Name => 'DefaultUserCrop',
+        Writable => 'rational64u',
+        WriteGroup => 'SubIFD',
+        Count => 4,
+        Protected => 1,
+    },
+    0xc7d5 => { #PH (in SubIFD1 of Nikon Z6/Z7 NEF images)
+        Name => 'NikonNEFInfo',
+        Condition => '$$valPt =~ /^Nikon\0/',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Nikon::NEFInfo',
+            Start => '$valuePtr + 18',
+            Base => '$start - 8',
+            ByteOrder => 'Unknown',
+        },
+    },
+    # 0xc7d6 - int8u: 1 (SubIFD1 of Nikon Z6/Z7 NEF)
+    0xc7e9 => { # DNG 1.5
+        Name => 'DepthFormat',
+        Writable => 'int16u',
+        Notes => 'tags 0xc7e9-0xc7ee added by DNG 1.5.0.0',
+        Protected => 1,
+        WriteGroup => 'IFD0',
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Linear',
+            2 => 'Inverse',
+        },
+    },
+    0xc7ea => { # DNG 1.5
+        Name => 'DepthNear',
+        Writable => 'rational64u',
+        Protected => 1,
+        WriteGroup => 'IFD0',
+    },
+    0xc7eb => { # DNG 1.5
+        Name => 'DepthFar',
+        Writable => 'rational64u',
+        Protected => 1,
+        WriteGroup => 'IFD0',
+    },
+    0xc7ec => { # DNG 1.5
+        Name => 'DepthUnits',
+        Writable => 'int16u',
+        Protected => 1,
+        WriteGroup => 'IFD0',
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Meters',
+        },
+    },
+    0xc7ed => { # DNG 1.5
+        Name => 'DepthMeasureType',
+        Writable => 'int16u',
+        Protected => 1,
+        WriteGroup => 'IFD0',
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Optical Axis',
+            2 => 'Optical Ray',
+        },
+    },
+    0xc7ee => { # DNG 1.5
+        Name => 'EnhanceParams',
+        Writable => 'string',
+        Protected => 1,
+        WriteGroup => 'IFD0',
+    },
     0xea1c => { #13
         Name => 'Padding',
         Binary => 1,
+        Protected => 1,
         Writable => 'undef',
         # must start with 0x1c 0xea by the WM Photo specification
@@ -2403,4 +4054,6 @@
         Name => 'OffsetSchema',
         Notes => "Microsoft's ill-conceived maker note offset difference",
+        Protected => 1,
+        Writable => 'int32s',
         # From the Microsoft documentation:
         #
@@ -2428,11 +4081,133 @@
         # they have taken no steps to address this.
     },
+    # 0xefee - int16u: 0 - seen this from a WIC-scanned image
 
     # tags in the range 0xfde8-0xfe58 have been observed in PS7 files
     # generated from RAW images.  They are all strings with the
-    # tag name at the start of the string.  To accomodate these types
+    # tag name at the start of the string.  To accommodate these types
     # of tags, all tags with values above 0xf000 are handled specially
     # by ProcessExif().
-
+    0xfde8 => {
+        Name => 'OwnerName',
+        Condition => '$$self{TIFF_TYPE} ne "DCR"', # (used for another purpose in Kodak DCR images)
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Owner's Name: $val"},
+        Notes => q{
+            tags 0xfde8-0xfdea and 0xfe4c-0xfe58 are generated by Photoshop Camera RAW.
+            Some names are the same as other EXIF tags, but ExifTool will avoid writing
+            these unless they already exist in the file
+        },
+    },
+    0xfde9 => {
+        Name => 'SerialNumber',
+        Condition => '$$self{TIFF_TYPE} ne "DCR"', # (used for another purpose in Kodak DCR SubIFD)
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Serial Number: $val"},
+    },
+    0xfdea => {
+        Name => 'Lens',
+        Condition => '$$self{TIFF_TYPE} ne "DCR"', # (used for another purpose in Kodak DCR SubIFD)
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Lens: $val"},
+    },
+    0xfe4c => {
+        Name => 'RawFile',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Raw File: $val"},
+    },
+    0xfe4d => {
+        Name => 'Converter',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Converter: $val"},
+    },
+    0xfe4e => {
+        Name => 'WhiteBalance',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"White Balance: $val"},
+    },
+    0xfe51 => {
+        Name => 'Exposure',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Exposure: $val"},
+    },
+    0xfe52 => {
+        Name => 'Shadows',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Shadows: $val"},
+    },
+    0xfe53 => {
+        Name => 'Brightness',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Brightness: $val"},
+    },
+    0xfe54 => {
+        Name => 'Contrast',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Contrast: $val"},
+    },
+    0xfe55 => {
+        Name => 'Saturation',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Saturation: $val"},
+    },
+    0xfe56 => {
+        Name => 'Sharpness',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Sharpness: $val"},
+    },
+    0xfe57 => {
+        Name => 'Smoothness',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Smoothness: $val"},
+    },
+    0xfe58 => {
+        Name => 'MoireFilter',
+        Avoid => 1,
+        PSRaw => 1,
+        Writable => 'string',
+        ValueConv => '$val=~s/^.*: //;$val',
+        ValueConvInv => q{"Moire Filter: $val"},
+    },
+
+    #-------------
     0xfe00 => {
         Name => 'KDC_IFD',
@@ -2448,4 +4223,23 @@
 );
 
+# conversions for Composite SubSec date/time tags
+my %subSecConv = (
+    # @val array: 0) date/time, 1) sub-seconds, 2) time zone offset
+    RawConv => q{
+        my $v;
+        if (defined $val[1] and $val[1]=~/^(\d+)/) {
+            my $subSec = $1;
+            # be careful here just in case the time already contains sub-seconds or a timezone (contrary to spec)
+            undef $v unless ($v = $val[0]) =~ s/( \d{2}:\d{2}:\d{2})(?!\.\d+)/$1\.$subSec/;
+        }
+        if (defined $val[2] and $val[0]!~/[-+]/ and $val[2]=~/^([-+])(\d{1,2}):(\d{2})/) {
+            $v = ($v || $val[0]) . sprintf('%s%.2d:%.2d', $1, $2, $3);
+        }
+        return $v;
+    },
+    PrintConv => '$self->ConvertDateTime($val)',
+    PrintConvInv => '$self->InverseDateTime($val)',
+);
+
 # EXIF Composite tags (plus other more general Composite tags)
 %Image::ExifTool::Exif::Composite = (
@@ -2459,11 +4253,20 @@
             2 => 'ExifImageWidth',
             3 => 'ExifImageHeight',
+            4 => 'RawImageCroppedSize', # (FujiFilm RAF images)
         },
         # use ExifImageWidth/Height only for Canon and Phase One TIFF-base RAW images
         ValueConv => q{
-            return "$val[2]x$val[3]" if $val[2] and $val[3] and
+            return $val[4] if $val[4];
+            return "$val[2] $val[3]" if $val[2] and $val[3] and
                     $$self{TIFF_TYPE} =~ /^(CR2|Canon 1D RAW|IIQ|EIP)$/;
-            return "$val[0]x$val[1]";
-        },
+            return "$val[0] $val[1]" if IsFloat($val[0]) and IsFloat($val[1]);
+            return undef;
+        },
+        PrintConv => '$val =~ tr/ /x/; $val',
+    },
+    Megapixels => {
+        Require => 'ImageSize',
+        ValueConv => 'my @d = ($val =~ /\d+/g); $d[0] * $d[1] / 1000000',
+        PrintConv => 'sprintf("%.*f", ($val >= 1 ? 1 : ($val >= 0.001 ? 3 : 6)), $val)',
     },
     # pick the best shutter speed value
@@ -2484,8 +4287,11 @@
         RawConv => '($val[0] || $val[1]) ? $val : undef',
         ValueConv => '$val[0] || $val[1]',
-        PrintConv => 'sprintf("%.1f", $val)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
     },
     LightValue => {
-        Notes => 'calculated LV -- similar to exposure value but includes ISO speed',
+        Notes => q{
+            calculated LV = 2 * log2(Aperture) - log2(ShutterSpeed) - log2(ISO/100);
+            similar to exposure value but normalized to ISO 100
+        },
         Require => {
             0 => 'Aperture',
@@ -2511,5 +4317,8 @@
     ScaleFactor35efl => { #26/PH
         Description => 'Scale Factor To 35 mm Equivalent',
-        Notes => 'this value and any derived values may be incorrect if image has been resized',
+        Notes => q{
+            this value and any derived values may be incorrect if the image has been
+            resized
+        },
         Groups => { 2 => 'Camera' },
         Desire => {
@@ -2518,23 +4327,24 @@
             2 => 'Composite:DigitalZoom',
             3 => 'FocalPlaneDiagonal',
-            4 => 'FocalPlaneXSize',
-            5 => 'FocalPlaneYSize',
-            6 => 'FocalPlaneResolutionUnit',
-            7 => 'FocalPlaneXResolution',
-            8 => 'FocalPlaneYResolution',
-            9 => 'ExifImageWidth',
-           10 => 'ExifImageHeight',
-           11 => 'CanonImageWidth',
-           12 => 'CanonImageHeight',
-           13 => 'ImageWidth',
-           14 => 'ImageHeight',
-        },
-        ValueConv => 'Image::ExifTool::Exif::CalcScaleFactor35efl(@val)',
+            4 => 'SensorSize',
+            5 => 'FocalPlaneXSize',
+            6 => 'FocalPlaneYSize',
+            7 => 'FocalPlaneResolutionUnit',
+            8 => 'FocalPlaneXResolution',
+            9 => 'FocalPlaneYResolution',
+           10 => 'ExifImageWidth',
+           11 => 'ExifImageHeight',
+           12 => 'CanonImageWidth',
+           13 => 'CanonImageHeight',
+           14 => 'ImageWidth',
+           15 => 'ImageHeight',
+        },
+        ValueConv => 'Image::ExifTool::Exif::CalcScaleFactor35efl($self, @val)',
         PrintConv => 'sprintf("%.1f", $val)',
     },
     CircleOfConfusion => {
         Notes => q{
-            this value may be incorrect if the image has been resized.  Calculated as
-            D/1440, where D is the focal plane diagonal in mm
+            calculated as D/1440, where D is the focal plane diagonal in mm.  This value
+            may be incorrect if the image has been resized
         },
         Groups => { 2 => 'Camera' },
@@ -2570,4 +4380,7 @@
             4 => 'SubjectDistance',
             5 => 'ObjectDistance',
+            6 => 'ApproximateFocusDistance',
+            7 => 'FocusDistanceLower',
+            8 => 'FocusDistanceUpper',
         },
         ValueConv => q{
@@ -2577,6 +4390,9 @@
                 $d or $d = 1e10;    # (use large number for infinity)
             } else {
-                $d = $val[4] || $val[5];
-                return undef unless defined $d;
+                $d = $val[4] || $val[5] || $val[6];
+                unless (defined $d) {
+                    return undef unless defined $val[7] and defined $val[8];
+                    $d = ($val[7] + $val[8]) / 2;
+                }
             }
             return 0 unless $f and $val[2];
@@ -2590,5 +4406,7 @@
             my @v = split ' ', $val;
             $v[1] or return sprintf("inf (%.2f m - inf)", $v[0]);
-            return sprintf("%.2f m (%.2f - %.2f)",$v[1]-$v[0],$v[0],$v[1]);
+            my $dof = $v[1] - $v[0];
+            my $fmt = ($dof>0 and $dof<0.02) ? "%.3f" : "%.2f";
+            return sprintf("$fmt m ($fmt - $fmt m)",$dof,$v[0],$v[1]);
         },
     },
@@ -2596,5 +4414,5 @@
         Description => 'Field Of View',
         Notes => q{
-            calculated for the long image dimension, this value may be incorrect for
+            calculated for the long image dimension.  This value may be incorrect for
             fisheye lenses, or if the image has been resized
         },
@@ -2640,7 +4458,7 @@
             2 => 'TimeCreated',
         },
+        RawConv => '($val[1] and $val[2]) ? $val : undef',
         ValueConv => q{
             return $val[0] if $val[0] and $val[0]=~/ /;
-            return undef unless $val[1] and $val[2];
             return "$val[1] $val[2]";
         },
@@ -2648,5 +4466,7 @@
     },
     ThumbnailImage => {
+        Groups => { 0 => 'EXIF', 1 => 'IFD1', 2 => 'Preview' },
         Writable => 1,
+        WriteGroup => 'All',
         WriteCheck => '$self->CheckImage(\$val)',
         WriteAlso => {
@@ -2659,9 +4479,45 @@
             1 => 'ThumbnailLength',
         },
+        Notes => q{
+            this tag is writable, and may be used to update existing thumbnails, but may
+            only create a thumbnail in IFD1 of certain types of files.  Note that for
+            this and other Composite embedded-image tags the family 0 and 1 groups match
+            those of the originating tags
+        },
         # retrieve the thumbnail from our EXIF data
-        RawConv => 'Image::ExifTool::Exif::ExtractImage($self,$val[0],$val[1],"ThumbnailImage")',
+        RawConv => q{
+            @grps = $self->GetGroup($$val{0});  # set groups from ThumbnailOffsets
+            Image::ExifTool::Exif::ExtractImage($self,$val[0],$val[1],"ThumbnailImage");
+        },
+    },
+    ThumbnailTIFF => {
+        Groups => { 2 => 'Preview' },
+        Require => {
+            0 => 'SubfileType',
+            1 => 'Compression',
+            2 => 'ImageWidth',
+            3 => 'ImageHeight',
+            4 => 'BitsPerSample',
+            5 => 'PhotometricInterpretation',
+            6 => 'StripOffsets',
+            7 => 'SamplesPerPixel',
+            8 => 'RowsPerStrip',
+            9 => 'StripByteCounts',
+        },
+        Desire => {
+            10 => 'PlanarConfiguration',
+            11 => 'Orientation',
+        },
+        # rebuild the TIFF thumbnail from our EXIF data
+        RawConv => q{
+            my $tiff;
+            ($tiff, @grps) = Image::ExifTool::Exif::RebuildTIFF($self, @val);
+            return $tiff;
+        },
     },
     PreviewImage => {
+        Groups => { 0 => 'EXIF', 1 => 'SubIFD', 2 => 'Preview' },
         Writable => 1,
+        WriteGroup => 'All',
         WriteCheck => '$self->CheckImage(\$val)',
         DelCheck => '$val = ""; return undef', # can't delete, so set to empty string
@@ -2669,5 +4525,5 @@
             PreviewImageStart  => 'defined $val ? 0xfeedfeed : undef',
             PreviewImageLength => 'defined $val ? 0xfeedfeed : undef',
-            PreviewImageValid  => 'defined $val and length $val ? 1 : 0',
+            PreviewImageValid  => 'defined $val and length $val ? 1 : 0', # (for Olympus)
         },
         Require => {
@@ -2680,4 +4536,8 @@
             3 => 'PreviewImageStart (1)',
             4 => 'PreviewImageLength (1)',
+        },
+        Notes => q{
+            this tag is writable, and may be used to update existing embedded images,
+            but not create or delete them
         },
         # note: extract 2nd preview, but ignore double-referenced preview
@@ -2693,10 +4553,16 @@
             }
             return undef if defined $val[2] and not $val[2];
+            @grps = $self->GetGroup($$val{0});
             return Image::ExifTool::Exif::ExtractImage($self,$val[0],$val[1],'PreviewImage');
         },
     },
     JpgFromRaw => {
+        Groups => { 0 => 'EXIF', 1 => 'SubIFD', 2 => 'Preview' },
         Writable => 1,
+        WriteGroup => 'All',
         WriteCheck => '$self->CheckImage(\$val)',
+        # Note: ExifTool 10.38 had disabled the ability to delete this -- why?
+        # --> added the DelCheck in 10.61 to re-enable this
+        DelCheck => '$val = ""; return undef', # can't delete, so set to empty string
         WriteAlso => {
             JpgFromRawStart  => 'defined $val ? 0xfeedfeed : undef',
